﻿//************************************************************************
//  Created:    2016/8/10 10:51
//  File base:  tester
//  Copyright:  iTest
//  Purpose:
//************************************************************************
#pragma once
#ifndef _TESTER_COMMON_H_
#define _TESTER_COMMON_H_

#include "wterror.h"
#include "alzdef.h"
#include <time.h>

#ifdef STD_CALL
#define CALL_MODE __stdcall
#else
#define CALL_MODE
#endif

//最大VSA单元数
#define MAX_VSA_UNIT_COUNT 4
//最大VSG单元数
#define MAX_VSG_UNIT_COUNT 4
//带有文件名的命令中文件名的最大长度
#define MAX_NAME_SIZE      256
//子网口最大数
#define MAX_SUB_NET_COUNT 8
//最大天线数
#define DF_MAX_ATT 8
//最大端口数
#define MAX_PORT_COUNT 16

//*****************************************************************************
//
//                         Enumerations
//
//*****************************************************************************



enum WT_TESTER_TYPE
{
    WT160,
    WT200,
    WT208 = 3,
    WT208C,
    WT300 = 14,
    WT328,
    WT318,
    WT328E,
    WTDEMO = 0xFFFF
};

//子仪器索引
enum WT_SUB_TESTER_INDEX
{
    WT_SUB_TESTER_INDEX_AUTO = -1,                      //INDEX自动分配
    WT_SUB_TESTER_INDEX0 = 1,                           //INDEX0
    WT_SUB_TESTER_INDEX1 = 2,                           //INDEX1
    WT_SUB_TESTER_INDEX2 = 3,                           //INDEX2
    WT_SUB_TESTER_INDEX3 = 4,                           //INDEX3
    WT_SUB_TESTER_INDEX4 = 5,                           //INDEX4
    WT_SUB_TESTER_INDEX5 = 6,                           //INDEX5
    WT_SUB_TESTER_INDEX6 = 7,                           //INDEX6
    WT_SUB_TESTER_INDEX7 = 8,                           //INDEX7
    WT_SUB_TESTER_INDEX_MAX = 8
};

// Enumeration for RF N-connector port selection.
enum WT_PORT_ENUM
{
    WT_PORT_OFF = 1,                                    // All RF port is disable
    WT_PORT_RF1 = 2,                                    // Use RF1
    WT_PORT_RF2 = 3,                                    // Use RF2
    WT_PORT_RF3 = 4,                                    // Use RF3
    WT_PORT_RF4 = 5,                                    // Use RF4
    WT_PORT_RF5 = 6,                                    // Use RF5
    WT_PORT_RF6 = 7,                                    // Use RF6
    WT_PORT_RF7 = 8,                                    // Use RF7
    WT_PORT_RF8 = 9,                                    // Use RF8
    WT_PORT_RF9 = 10,                                   // Use RF9
    WT_PORT_RF10 = 11,                                  // Use RF10
    WT_PORT_RF11 = 12,                                  // Use RF11
    WT_PORT_RF12 = 13,                                  // Use RF12
    WT_PORT_RF13 = 14,                                  // Use RF13
    WT_PORT_RF14 = 15,                                  // Use RF14
    WT_PORT_RF15 = 16,                                  // Use RF15
    WT_PORT_RF16 = 17,                                  // Use RF16
    WT_PORT_MAX = 0xFF
};

enum WT_CONNECT_TYPE
{
    WT_CONNECT_TYPE_NORMAL,                             //普通连接
    WT_CONNECT_TYPE_FORCE,                              //强制连接
    WT_CONNECT_TYPE_MONITOR,                            //监视连接
    WT_CONNECT_TYPE_MultiUser,                          //子连接
    WT_CONNECT_TYPE_MANAGE,                             //管理连接
    WT_CONNECT_TYPE_DEMO                                //DEMO连接
};


//VSG状态
enum WT_VSG_STATE
{
    WT_VSG_VSA_STATE_DONE,                              //VSA/VSG已完成
    WT_VSG_VSA_STATE_RUNNING,                           //VSA/VSG正在运行
    WT_VSG_VSA_STATE_TIMEOUT,                           //VSA/VSG超时
    WT_VSG_VSA_STATE_ERR_DONE,                          //VSA/VSG出错
    WT_VSG_VSA_STATE_WAITING
};

//连接状态
enum WT_CONNECT_STATE
{
    WT_CONNECT_DEVICE_NOT_EXSIT = -1,                   //设备不存在
    WT_CONNECT_STATE_IDLE = 0,                          //设备空闲，未被连接
    WT_CONNECT_STATE_BUSY = 1,                          //设备已被连接
};

enum WT_COMUNICATE_TYPE
{
    WT_COMU_TYPE_TCP,                                   //TCP通信方式
    WT_COMU_TYPE_UDP,                                   //UDP通信方式
    WT_COMU_TYPE_SCPI,                                  //SCPI通信
    WT_COMU_TYPE_VISA                                   //VISA通信
};

enum WT_SAVE_SIG_FILE_OPTION
{
    WT_SAVE_RAW_DATA,                                   //保存原始数据
    WT_SAVE_COMPENSATED_DATA                            //保存补偿后的数据,
};

enum WT_VSA_AVERAGE_TYPE
{
    WT_CAPTURE_ARITHMETIC_AVERAGE,                      //多次抓取取算术平均
    WT_CAPTURE_MOVING_AVERAGE,                          //多次抓取取滑动平均
    WT_SEGMENT_ARITHMETIC_AVERAGE,                      //多帧取算术平均
    //WT_SEGMENT_MOVING_AVERAGE                         //多帧取滑动平均
};

enum FILE_OPTION
{
    GET_WAVE_FILE,                                      //获取波形文件
    DELETE_WAVE_FILE,                                   //删除波形文件
    ADD_WAVE_FILE,                                      //添加波形文件
    GET_REF_FILE,                                       //获取参考文件
    DELETE_REF_FILE,                                    //删除参考文件
    ADD_REF_FILE                                        //添加参考文件
};

enum AX_TB_ANALYZE_ENUM
{
    AX_TB_ANALYZE_EXIT = -1,    ///< 退出TB分析模式    
    AX_TB_BASE_TYPE = 0,        ///< 配置AlzParamAxTriggerBase分析结构体
    AX_TB_REF_FILE = 2,         ///< 加载.tb文件
};
//*****************************************************************************
//
// The following are the signals, which are predefined for use with the tester.
//
//*****************************************************************************
enum WT_SIGNAL_ENUM
{
    // Wave file Defined by user.
    SIG_USERFILE,

    // Continuous Wave.
    SIG_CW_SIN0,
    // Continuous Wave Sin 100KHz.
    SIG_CW_SIN100K,
    // Continuous Wave Sin 1MHZ.
    SIG_CW_SIN1M,
    // Continuous Wave Sin -100KHZ.
    SIG_CW_SINNEG100K,

    // 802.11g  6 Mbit/s.
    SIG_802_11_G_6MBS = 101,
    // 802.11g  9 Mbit/s.
    SIG_802_11_G_9MBS,
    // 802.11g 12 Mbit/s.
    SIG_802_11_G_12MBS,
    // 802.11g 18 Mbit/s.
    SIG_802_11_G_18MBS,
    // 802.11g 24 Mbit/s.
    SIG_802_11_G_24MBS,
    // 802.11g 36 Mbit/s.
    SIG_802_11_G_36MBS,
    // 802.11g 48 Mbit/s.
    SIG_802_11_G_48MBS,
    // 802.11g 54 Mbit/s.
    SIG_802_11_G_54MBS,

    // 802.11n 20M MCS0.
    SIG_HT_20_MCS0 = 201,
    // 802.11n 20M MCS1.
    SIG_HT_20_MCS1,
    // 802.11n 20M MCS2.
    SIG_HT_20_MCS2,
    // 802.11n 20M MCS3.
    SIG_HT_20_MCS3,
    // 802.11n 20M MCS4.
    SIG_HT_20_MCS4,
    // 802.11n 20M MCS5.
    SIG_HT_20_MCS5,
    // 802.11n 20M MCS6.
    SIG_HT_20_MCS6,
    // 802.11n 20M MCS7.
    SIG_HT_20_MCS7,

    // 802.11n 40M MCS0.
    SIG_HT_40_MCS0 = 301,
    // 802.11n 40M MCS1.
    SIG_HT_40_MCS1,
    // 802.11n 40M MCS2.
    SIG_HT_40_MCS2,
    // 802.11n 40M MCS3.
    SIG_HT_40_MCS3,
    // 802.11n 40M MCS4.
    SIG_HT_40_MCS4,
    // 802.11n 40M MCS5.
    SIG_HT_40_MCS5,
    // 802.11n 40M MCS6.
    SIG_HT_40_MCS6,
    // 802.11n 40M MCS7.
    SIG_HT_40_MCS7,

    // 802.11ac 20M MCS0.
    SIG_VHT_20_MCS0 = 401,
    // 802.11ac 20M MCS1.
    SIG_VHT_20_MCS1,
    // 802.11ac 20M MCS2.
    SIG_VHT_20_MCS2,
    // 802.11ac 20M MCS3.
    SIG_VHT_20_MCS3,
    // 802.11ac 20M MCS4.
    SIG_VHT_20_MCS4,
    // 802.11ac 20M MCS5.
    SIG_VHT_20_MCS5,
    // 802.11ac 20M MCS6.
    SIG_VHT_20_MCS6,
    // 802.11ac 20M MCS7.
    SIG_VHT_20_MCS7,
    // 802.11ac 20M MCS8.
    SIG_VHT_20_MCS8,

    // 802.11ac 40M MCS0.
    SIG_VHT_40_MCS0 = 501,
    // 802.11ac 40M MCS1.
    SIG_VHT_40_MCS1,
    // 802.11ac 40M MCS2.
    SIG_VHT_40_MCS2,
    // 802.11ac 40M MCS3.
    SIG_VHT_40_MCS3,
    // 802.11ac 40M MCS4.
    SIG_VHT_40_MCS4,
    // 802.11ac 40M MCS5.
    SIG_VHT_40_MCS5,
    // 802.11ac 40M MCS6.
    SIG_VHT_40_MCS6,
    // 802.11ac 40M MCS7.
    SIG_VHT_40_MCS7,
    // 802.11ac 40M MCS8.
    SIG_VHT_40_MCS8,
    // 802.11ac 40M MCS9.
    SIG_VHT_40_MCS9,

    // 802.11ac 80M MCS0.
    SIG_VHT_80_MCS0 = 601,
    // 802.11ac 80M MCS1.
    SIG_VHT_80_MCS1,
    // 802.11ac 80M MCS2.
    SIG_VHT_80_MCS2,
    // 802.11ac 80M MCS3.
    SIG_VHT_80_MCS3,
    // 802.11ac 80M MCS4.
    SIG_VHT_80_MCS4,
    // 802.11ac 80M MCS5.
    SIG_VHT_80_MCS5,
    // 802.11ac 80M MCS6.
    SIG_VHT_80_MCS6,
    // 802.11ac 80M MCS7.
    SIG_VHT_80_MCS7,
    // 802.11ac 80M MCS8.
    SIG_VHT_80_MCS8,
    // 802.11ac 80M MCS9.
    SIG_VHT_80_MCS9,

    // 802.11b 1 Mbit/s.
    SIG_802_11_B_1MBS = 701,
    // 802.11b 2 Mbit/s.
    SIG_802_11_B_2MBS,
    // 802.11b 5.5 Mbit/s.
    SIG_802_11_B_5_5MBS,
    // 802.11b 11 Mbit/s.
    SIG_802_11_B_11MBS,

    //*** Begined with FW version 3.0.1.4 ***

    // 802.11n 20M MCS0 ShortGI.
    SIG_HT_20_MCS0_ShortGI = 1201,
    // 802.11n 20M MCS1 ShortGI.
    SIG_HT_20_MCS1_ShortGI,
    // 802.11n 20M MCS2 ShortGI.
    SIG_HT_20_MCS2_ShortGI,
    // 802.11n 20M MCS3 ShortGI.
    SIG_HT_20_MCS3_ShortGI,
    // 802.11n 20M MCS4 ShortGI.
    SIG_HT_20_MCS4_ShortGI,
    // 802.11n 20M MCS5 ShortGI.
    SIG_HT_20_MCS5_ShortGI,
    // 802.11n 20M MCS6 ShortGI.
    SIG_HT_20_MCS6_ShortGI,
    // 802.11n 20M MCS7 ShortGI.
    SIG_HT_20_MCS7_ShortGI,

    // 802.11n 40M MCS0 ShortGI.
    SIG_HT_40_MCS0_ShortGI = 1301,
    // 802.11n 40M MCS1 ShortGI.
    SIG_HT_40_MCS1_ShortGI,
    // 802.11n 40M MCS2 ShortGI.
    SIG_HT_40_MCS2_ShortGI,
    // 802.11n 40M MCS3 ShortGI.
    SIG_HT_40_MCS3_ShortGI,
    // 802.11n 40M MCS4 ShortGI.
    SIG_HT_40_MCS4_ShortGI,
    // 802.11n 40M MCS5 ShortGI.
    SIG_HT_40_MCS5_ShortGI,
    // 802.11n 40M MCS6 ShortGI.
    SIG_HT_40_MCS6_ShortGI,
    // 802.11n 40M MCS7 ShortGI.
    SIG_HT_40_MCS7_ShortGI,

    // 802.11ac 20M MCS0 ShortGI.
    SIG_VHT_20_MCS0_ShortGI = 1401,
    // 802.11ac 20M MCS1 ShortGI.
    SIG_VHT_20_MCS1_ShortGI,
    // 802.11ac 20M MCS2 ShortGI.
    SIG_VHT_20_MCS2_ShortGI,
    // 802.11ac 20M MCS3 ShortGI.
    SIG_VHT_20_MCS3_ShortGI,
    // 802.11ac 20M MCS4 ShortGI.
    SIG_VHT_20_MCS4_ShortGI,
    // 802.11ac 20M MCS5 ShortGI.
    SIG_VHT_20_MCS5_ShortGI,
    // 802.11ac 20M MCS6 ShortGI.
    SIG_VHT_20_MCS6_ShortGI,
    // 802.11ac 20M MCS7 ShortGI.
    SIG_VHT_20_MCS7_ShortGI,
    // 802.11ac 20M MCS8 ShortGI.
    SIG_VHT_20_MCS8_ShortGI,

    // 802.11ac 40M MCS0 ShortGI.
    SIG_VHT_40_MCS0_ShortGI = 1501,
    // 802.11ac 40M MCS1 ShortGI.
    SIG_VHT_40_MCS1_ShortGI,
    // 802.11ac 40M MCS2 ShortGI.
    SIG_VHT_40_MCS2_ShortGI,
    // 802.11ac 40M MCS3 ShortGI.
    SIG_VHT_40_MCS3_ShortGI,
    // 802.11ac 40M MCS4 ShortGI.
    SIG_VHT_40_MCS4_ShortGI,
    // 802.11ac 40M MCS5 ShortGI.
    SIG_VHT_40_MCS5_ShortGI,
    // 802.11ac 40M MCS6 ShortGI.
    SIG_VHT_40_MCS6_ShortGI,
    // 802.11ac 40M MCS7 ShortGI.
    SIG_VHT_40_MCS7_ShortGI,
    // 802.11ac 40M MCS8 ShortGI.
    SIG_VHT_40_MCS8_ShortGI,
    // 802.11ac 40M MCS9 ShortGI.
    SIG_VHT_40_MCS9_ShortGI,

    // 802.11ac 80M MCS0 ShortGI.
    SIG_VHT_80_MCS0_ShortGI = 1601,
    // 802.11ac 80M MCS1 ShortGI.
    SIG_VHT_80_MCS1_ShortGI,
    // 802.11ac 80M MCS2 ShortGI.
    SIG_VHT_80_MCS2_ShortGI,
    // 802.11ac 80M MCS3 ShortGI.
    SIG_VHT_80_MCS3_ShortGI,
    // 802.11ac 80M MCS4 ShortGI.
    SIG_VHT_80_MCS4_ShortGI,
    // 802.11ac 80M MCS5 ShortGI.
    SIG_VHT_80_MCS5_ShortGI,
    // 802.11ac 80M MCS6 ShortGI.
    SIG_VHT_80_MCS6_ShortGI,
    // 802.11ac 80M MCS7 ShortGI.
    SIG_VHT_80_MCS7_ShortGI,
    // 802.11ac 80M MCS8 ShortGI.
    SIG_VHT_80_MCS8_ShortGI,
    // 802.11ac 80M MCS9 ShortGI.
    SIG_VHT_80_MCS9_ShortGI,

    // 802.11b 1 Mbit/s Short Preamble. Invalid.
    SIG_802_11_B_1MBS_ShortPreamble = 1701,
    // 802.11b 2 Mbit/s   Short Preamble.
    SIG_802_11_B_2MBS_ShortPreamble,
    // 802.11b 5.5 Mbit/s Short Preamble.
    SIG_802_11_B_5_5MBS_ShortPreamble,
    // 802.11b 11 Mbit/s  Short Preamble.
    SIG_802_11_B_11MBS_ShortPreamble,

    // Wave file Defined by Tester.
    SIG_TESTERFILE = 5000,


    SIG_LAST
};

// Enumeration for signal modulation source.
enum WT_SOURCE_ENUM
{
    // Internal modulation from wave.
    WT_SOURCE_WAVE,
    // Internal modulation from signal generator.
    WT_SOURCE_SIGNAL_GENERATOR,
    // Undefined default modulation source.
    WT_SOURCE_UNDEFINED
};

enum WT_TRIG_TYPE_ENUM
{
    // Free running ADC sampling.
    WT_TRIG_TYPE_FREE_RUN,
    // ADC External Trigger selected.
    WT_TRIG_TYPE_EXT,
    // ADC IF Trigger selected - trigger calibration will be performed.
    WT_TRIG_TYPE_IF,
    WT_TRIG_TYPE_IF_NO_CAL
};

enum WT_RANGE_GET_OPTION
{
    WT_STANDARD_RANGE,
    WT_ACTUAL_RANGE
};

//测试类型定义
enum TEST_TYPE
{
    TEST_SISO,                                          //SISO
    //TEST_80_80M = 1,                                  //80+80M
    //TEST_SELF_MIMO = 2,                               //单机MIMO
    TEST_MULTI_MIMO = 3,                                //多机MIMO
    //TEST_CMIMO = 4,                                   //CMIMO
    TEST_SWITCHED_MIMO = 5                              //Switched MIMO
};

#define IP_MAX_LEN                              16
#define MAC_ADDR_MAX_LEN                        18
#define WT_SN_MAX_LEN                           80
#define WT_COM_MAX_LEN                          40
#define WT_VER_DATA_LEN                         20
#define WT_MODULES_TYPE_LEN                     8
#define WT_LICENSE_NAME_LEN                     32
#define WT_MODULES_MAX_NUM                      8

//VSA配置
typedef struct
{
    double  Freq;                                               //VSA中心频率1，单位：Hz
    double  Freq2;                                              //VSA中心频率2，单位：Hz。仅80+80时使用
    double  FreqOffset;                                         //频率偏移，单位Hz。最小值10KHz，最小步进值1KHz
    int     VsaUnitMask[WT_SUB_TESTER_INDEX_MAX];               //业务单元掩码。默认值等于0
    double  MaxPower[WT_SUB_TESTER_INDEX_MAX];                  //输入的最大功率,dBm; (最好在实际输出到仪器的功率基础上再加12dB，如果接收功率范围未知，建议事先Auto Range)
    int     RfPort[WT_SUB_TESTER_INDEX_MAX];                    //指定VSA使用的RF端口
    double  ExtPathLoss[WT_SUB_TESTER_INDEX_MAX];               //外部衰减1。对应VSA中心频率1的衰减值。单位：dB
    double  ExtPathLoss2[WT_SUB_TESTER_INDEX_MAX];              //外部衰减2。对应VSA中心频率2的衰减值。仅80+80时候用
    int     ValidNum;                                           //VsaUnitMask等的有效值，默认值等于1
    double  SmpTime;                                            //采样时间。单位：second(秒)
    double  SamplingFreq;                                       //VSA采样带宽，单位Hz。默认240MHz

    int     Demode;                                             //信号demode
    int     TrigType;                                           //触发模式,WT_TRIG_TYPE_ENUM
    double  TrigLevel;                                          //触发电平,与max_power的差距,单位：dB
    double  TrigTimeout;                                        //触发等待超时，单位：second(秒)（该时间与TimeoutWaiting的时间相互独立）
    double  TrigPretime;                                        //触发保留时间，单位：second(秒)。保留触发前若干时间内的数据，取值范围[10us-300us]
    double  MaxIFGGap;                                          //最大帧间隔，单位：second(秒)。取值范围[10ms-2000ms]
    double  TimeoutWaiting;                                     //在多连接情况下，等待的最大时间，单位：second(秒)。默认值为4 second(秒)
} VsaParameter;


//VSA Avg配置
typedef struct
{
    int     AvgCount;                                           //平均次数
    int     AvgType;                                            //平均类型
} VsaAvgParameter;

//VSG Average Parameter
typedef struct
{
    double  Freq;                                               //VSG中心频率1，单位：Hz
    double  Freq2;                                              //VSG中心频率2，单位：Hz。仅80+80时使用
    double  FreqOffset;                                         //频率偏移，单位Hz。最小值10KHz，最小步进值1KHz
    double  SamplingFreq;                                       //VSG采样带宽，单位Hz。默认240MHz
    int     VsgUnitMask[WT_SUB_TESTER_INDEX_MAX];               //业务单元掩码，默认值等于0
    double  Power[WT_SUB_TESTER_INDEX_MAX];                     //VSG功率，单位：dBm
    int     RfPort[WT_SUB_TESTER_INDEX_MAX];                    //指定VSG使用的RF端口

    double  TimeoutWaiting;                                     //在多连接情况下，等待的最大时间，单位：second(秒)。默认值为8 second(秒)
} VsgAvgParameter;

//VSG基本配置
typedef struct
{
    double  Freq;                                               //VSG中心频率1，单位：Hz
    double  Freq2;                                              //VSG中心频率2，单位：Hz。仅80+80时使用
    double  FreqOffset;                                         //频率偏移，单位Hz。最小值10KHz，最小步进值1KHz
    double  SamplingFreq;                                       //VSG采样带宽，单位Hz。默认240MHz
    int     VsgUnitMask[WT_SUB_TESTER_INDEX_MAX];               //业务单元掩码，默认值等于0
    double  Power[WT_SUB_TESTER_INDEX_MAX];                     //VSG功率，单位：dBm
    int     RfPort[WT_SUB_TESTER_INDEX_MAX];                    //指定VSG使用的RF端口
    double  ExtPathLoss[WT_SUB_TESTER_INDEX_MAX];               //外部衰减1，对应VSG中心频率1的衰减值。单位：dB
    double  ExtPathLoss2[WT_SUB_TESTER_INDEX_MAX];              //外部衰减2，对应VSG中心频率2的衰减值。单位：dB。仅80+80时候用
    int     ValidNum;                                           //VsgUnitMask等的有效值。默认值等于1

    double  TimeoutWaiting;                                     //在多连接情况下，等待的最大时间，单位：second(秒)。默认值为8 second(秒)
    int     Reserved[10];                                       //保留位
} VsgParameter;


//波形文件配置(兼容多PN)
typedef struct
{
    char WaveName[MAX_NAME_SIZE];                               //本地波形文件路径
    char SaveWaveName[MAX_NAME_SIZE];                           //波形文件保存到下位机的文件名字。注意和WaveName区分
    int Wave2Flag;                                              //默认值等于0。仅80+80时设置为1
} VsgWaveParameter;


//VSG行为定义
typedef struct
{
    unsigned int Repeat;                                        //循环发送次数，0表示无限次发送
    double       Wave_gap;                                      //两次发送间隔,单位：second(秒)
    double       GapPower;                                      //间隔功率，单位：dbm
    double       FreqOffset;                                    //频率偏移，单位：HZ
    double       PowerOffset;                                   //相对功率原点的功率偏差，单位：dB
    int          WaveType;                                      //Wave类型，SIG_USERFILE: 读取本地wave文件; SIG_TESTERFILE: 使用预先下载到仪器的wave文件;
    char         WaveName[MAX_NAME_SIZE];                       //如果信号文件从本地获取，需指定下载到仪器后的信号文件名称。
} VsgPattern;


typedef struct
{
    unsigned int StartIdx;                                      //第一个发送的PN编号
    unsigned int SendCnt;                                       //发送多少个PN
} PnItemHead;


//连接单元
typedef struct
{
    char Ip[IP_MAX_LEN];                                        //仪器IP地址
    int SubTesterIndex;                                         //子仪器编号。默认值等于WT_SUB_TESTER_INDEX_AUTO 最大值:WT_SUB_TESTER_INDEX_MAX
} ConnectedUnit;

//子仪器资源分配配置
typedef struct
{
    /************************************************************
    The ASCII decimal number specifying the active RF ports
    each binary bit represents a single physical RF port
    The least significant bit represents port 1 and so on for a maximum of 8 ports
    A bit set to 1 indicates that the port is active
    A bit set to 0 indicates that the port is inactive
    By default, port 1 is ON and all other ports are OFF
    *************************************************************/
    int RfPort;                                                 //RF口掩码(与网口一一对应，RF1对应子网口1，RF2对应子网口2，依次类推)
    /************************************************************
    The ASCII decimal number specifying the active VSA units
    each binary bit represents a single physical VSA units
    The least significant bit represents VSA 1 and so on for a maximum of 4 units
    A bit set to 1 indicates that the VSA unit is active
    A bit set to 0 indicates that the VSA unit is inactive
    By default, VSA unit 1 is ON and all other VSA unit are OFF
    *************************************************************/
    int VsaUnit;                                                //VSA单元掩码
    /************************************************************
    The ASCII decimal number specifying the active VSG units
    each binary bit represents a single physical VSG units
    The least significant bit represents VSG 1 and so on for a maximum of 4 units
    A bit set to 1 indicates that the VSG unit is active
    A bit set to 0 indicates that the VSG unit is inactive
    By default, VSG unit 1 is ON and all other VSG unit are OFF
    *************************************************************/
    int VsgUnit;                                                //VSG单元掩码
} SubTesterCfg;


//虚拟网口配置
typedef struct
{
    //  *****************************************************************************
    //                              基础配置，该部分必须配置
    //  *****************************************************************************

    char VirAddr[MAX_SUB_NET_COUNT][IP_MAX_LEN];                // 虚拟IP,最多8个子网口，依次对应1~8子网口。不需要配置的子网口赋值为NULL
    char DutAddr[IP_MAX_LEN];                                   // DUT IP,必须与仪器IP不在同一网段

    //  *****************************************************************************
    //                             DUT作为TFTP Server时
    //
    //          无TFTP需求时，以下IP都设置为空
    //
    //          需配置DUT在TFTP状态下指定的Server IP
    //  *****************************************************************************
    char DutTftpServerAddr[IP_MAX_LEN];                         // DUT IP

    //  *****************************************************************************
    //                           PC 作为FFTP Server时
    //
    //          无TFTP需求时，以下IP都设置为空
    //
    //          当PC作为TFTP Server时，需配置实际作为Server的PC IP
    //          还需配置DUT在TFTP状态下所使用的Client IP以及DUT所指定的Server IP
    //  *****************************************************************************
    char TftpServerAddr[IP_MAX_LEN];                            // TFTP Server IP
    char TftpClientAddr[IP_MAX_LEN];                            // DUT IP
    char TftpServerPCAddr[IP_MAX_LEN];                          // PC IP,需确保该IP与DUT的虚拟IP在同一网络

} VirtualNetType;


typedef struct
{
    enum WT_PORT_ENUM Port;
    int Valid;
} SW_MIMO_Ant;
typedef struct
{
    SW_MIMO_Ant VSA_Port[MAX_PORT_COUNT];
} WT_SW_MIMO_Ant;

typedef struct
{
    int DataLen;                                            //数据长度，单位：byte
    int DataTypeSize;                                       //数据类型长度，单位：byte
    char *Data;                                             //数据内容
} VsaResult;

////仪器概况
typedef struct
{
    /************************************************************
    Tester IP address
    ************************************************************/
    char Ip[IP_MAX_LEN];                                // IP地址
    /************************************************************
    Tester type:WT-300 or WT-328 or other types
    ************************************************************/
    char TesterType[WT_COM_MAX_LEN];                    //仪器类型
    /************************************************************
    Tester SN
    ************************************************************/
    char SN[WT_SN_MAX_LEN];                             // SN码
    /************************************************************
    Tester alias
    ************************************************************/
    char Name[WT_COM_MAX_LEN];                          // 别名     "iTest Tester"
    /************************************************************
    Tester firmware version
    ************************************************************/
    char FwVersion[WT_COM_MAX_LEN];                     //固件版本
} TesterOverview;
#ifndef LINUX_SCPI
enum LOG_QUERY_TYPE
{
    LOG_QUERY_SERVER_ID,
    LOG_QUERY_HW,
    LOG_QUERY_TIME,
    LOG_QUERY_OP,
    LOG_QUERY_All,
    LOG_QUERY_SQL,
};
#endif
typedef struct
{
    int		WIFI8080DulPortMode;					//80+80是否采用双端口模式。
    int     VsaRfPort[WT_SUB_TESTER_INDEX_MAX];		//8080 多端口模式
    double	RfPort_MaxPower[WT_SUB_TESTER_INDEX_MAX];
    double	RfPort_TrigLevel[WT_SUB_TESTER_INDEX_MAX];
    int     Reserved[64];
}ExtendVsaParameter;

typedef struct
{
    int		WIFI8080DulPortMode;					//80+80是否采用双端口模式。
    int     VsgRfPort[WT_SUB_TESTER_INDEX_MAX];		//8080 多端口模式
    double	VsgPower[WT_SUB_TESTER_INDEX_MAX];		//8080 多端口模式，每个RF口的功率
    int     Reserved[64];
}ExtendVsgParameter;

#define  AX_USER_COUNT 74

typedef struct
{
    TesterOverview overView;
    char BootTime[WT_COM_MAX_LEN];						//开机时间
    char BootElapsedTime[WT_COM_MAX_LEN];				//开机时长
    char Reserved[MAX_NAME_SIZE];						//保留位
}ExternedTesterOverview;


typedef struct
{
    double  Freq;                                                   //VSA中心频率1，单位：Hz
    double  Freq2;                                                  //VSA中心频率2，单位：Hz。仅80+80时使用
    double  VsaMaxPower[WT_SUB_TESTER_INDEX_MAX];                   //输入的最大功率,dBm; (最好在实际输出到仪器的功率基础上再加12dB，如果接收功率范围未知，建议事先Auto Range)
    int     VsaRfPort[WT_SUB_TESTER_INDEX_MAX];                     //指定VSA使用的RF端口
    double  VsaExtPathLoss[WT_SUB_TESTER_INDEX_MAX];                //外部衰减1。对应VSA中心频率1的衰减值。单位：dB
    double  VsaExtPathLoss2[WT_SUB_TESTER_INDEX_MAX];               //外部衰减2。对应VSA中心频率2的衰减值。仅80+80时候用
    double  VsaSmpTime;                                             //采样时间。单位：second(秒)
    int     VsaDemode;                                              //信号demode

    double  VsgPower[WT_SUB_TESTER_INDEX_MAX];                      //VSG功率，单位：dBm
    int     VsgRfPort[WT_SUB_TESTER_INDEX_MAX];                     //指定VSG使用的RF端口
    double  VsgExtPathLoss[WT_SUB_TESTER_INDEX_MAX];                //VSG外部衰减1，对应VSG中心频率1的衰减值。单位：dB
    double  VsgExtPathLoss2[WT_SUB_TESTER_INDEX_MAX];               //VSG外部衰减2，对应VSG中心频率2的衰减值。单位：dB。仅80+80时候用
    double  VsgGap;                                                 //VSG gap
    int     VsgWaveType;                                            //0使用本地信号文件，1使用仪器内部文件。配置值等于1时，配置VsgSaveWaveName即可
    char    VsgWaveName[MAX_NAME_SIZE];                             //VSG本地波形文件路径
    char    VsgSaveWaveName[MAX_NAME_SIZE];                         //VSG波形文件保存到下位机的文件名字。注意和WaveName区分
    int     VsgWave2Flag;                                           //VSG,80+80时设置为1。默认值等于0
} AxTBBindParameter;

#include "TesterWave.h"

#endif
