#pragma once
#ifndef _TESTER_WAVE_H_
#define _TESTER_WAVE_H_

#define AX_RU_COUNT     AX_USER_COUNT
#define MUMIMO_8_USER 8
#define MAX_SEGMENT 2
#define AC_MUMIMO_4_USER 4
#define MAX_MPDU_COUNT 64

enum PPDU_11AX_ENUM
{
    //11AX wave PPDU type enum
    HE_SU_PPDU = 1,
    HE_MU_PPDU = 2,
    HE_TB_PPDU = 3,
    HE_EXTEND_PPDU = 4,

    HE_UNKNOWN_PPDU = 0xFF
};

enum PPDU_11AC_ENUM
{
    //11AC wave PPDU type enum
    VHT_SU_PPDU = 0,
    VHT_MUMIMO_PPDU = 1
};


enum WT_BT_PACKET_ENUM
{
    //LCP
    BT_ID,
    BT_NULL,
    BT_POLL,
    BT_FHS,

    BT_DM1,
    BT_DH1,
    BT_DM3,
    BT_DH3,
    BT_DM5,
    BT_DH5,
    BT_AUX1,

    BT_2_DH1,
    BT_2_DH3,
    BT_2_DH5,
    BT_3_DH1,
    BT_3_DH3,
    BT_3_DH5,

    BT_HV1,
    BT_HV2,
    BT_HV3,
    BT_DV,

    BT_EV3,
    BT_EV4,
    BT_EV5,

    BT_2_EV3,
    BT_2_EV5,
    BT_3_EV3,
    BT_3_EV5,

    BT_LE_TEST,
    BT_LE_1M_TEST = BT_LE_TEST,
    BT_LE_2M_TEST,
    BT_LE_CODED_TEST,

    BT_CNT = 0xFFFF
};

enum WT_BT_PSDU_ENUM
{
    BT_PSDU_PRBS9 = 0,
    BT_PSDU_11110000 = 1,
    BT_PSDU_10101010 = 2,
    BT_PSDU_PRBS15 = 3,
    BT_PSDU_11111111 = 4,
    BT_PSDU_00000000 = 5,
    BT_PSDU_00001111 = 6,
    BT_PSDU_01010101 = 7,
    BT_PSDU_RANDOM = 8,

    BT_PSDU_UNKNOWN = 0xFF
};

typedef struct
{
    int TriggerType;
    int	TBLength;
    int	MoreTF;
    int	CSRequired;
    int	TBULBW;
    int	TBGILTF;
    int	TBMMMode;
    int	TBLTFSym;
    int	TBSTBC;
    int	TBLDPCExtra;
    int	APTxPower;
    int TBAfactor;
    int	TBPE;
    int mPad;
    int TBSR[4];
    int	TBDoppler;
    int	TBUserNum;
    int	TBAID[AX_USER_COUNT];
    int TBRUIndex[AX_USER_COUNT];
    int TBSegment[AX_USER_COUNT];
    int TBCoding[AX_USER_COUNT];
    int TBMCS[AX_USER_COUNT];
    int TBDCM[AX_USER_COUNT];
    int TBSSStart[AX_USER_COUNT];
    int TBSSCount[AX_USER_COUNT];
    int TBRSSI[AX_USER_COUNT];
    int TBSpacingFactor[AX_USER_COUNT];
    int	TBAggLimit[AX_USER_COUNT];
    int	TBPreAC[AX_USER_COUNT];
    int	TBMultiplexing[AX_USER_COUNT];
    int TBRxTxMap[AX_USER_COUNT];
    int TBBARInfoLen;
    unsigned char 	TBBARControl[4];
    unsigned char 	TBBARInfo[4];
    int TBMidamble_Periodicity;
    int PE_Disambiguity;
    double Reserved[255];   //λ
} TriggerFrameSetting;

typedef struct
{
    int psduLen;                            //psdu
    int psduType;                           //psdu. PSDU_TYPE_ENUM
    int scrambler;                          //
    int CRCCheckEnable;                     //CRCУʹܡ1ʾEnable0ʾDisable
    int MacHeaderEnable;                    //MACͷʹܣpsduǷMAC1ʾEnable0ʾDisable
    unsigned char FrameControl[2];          //ģʽ-û. ʮƱʾʽ0011
    unsigned char DurationID[2];            //ģʽ-ӳ. ʮƱʾʽ0x00, 0x1A
    unsigned char SequenceControl[2];       //ģʽ-. ʮƱʾʽ0A11
    unsigned char MacAddress1[6];           //Mac1.   ʮƱʾʽ0x11,0xAA,0x22,0xBB,0x33,0xCC
    unsigned char MacAddress2[6];           //Mac2.   ʮƱʾʽ0x11,0xAA,0x22,0xBB,0x33,0xCC
    unsigned char MacAddress3[6];           //Mac3.   ʮƱʾʽ0x11,0xAA,0x22,0xBB,0x33,0xCC
    unsigned char MacAddress4[6];           //Mac4.   ʮƱʾʽ0x11,0xAA,0x22,0xBB,0x33,0xCC
    int MPDUCount;
    int MPDULength[MAX_MPDU_COUNT];
    int Reserved[191];                      //λ
} WIFI_PSDU;

typedef struct
{
    int DataRate;                           ///< 11aź. DATARATE_11A_ENUM
    WIFI_PSDU psdu;                         ///< PSDU
    int Reserved[128];                      ///< λ
} Set11A;

typedef struct
{
    int DataRate;                           ///< 11bź. DATARATE_11B_ENUM
    int Preamble;                           ///< ǰ. ϸݼenum PREAMBLE_TYPE
    int Fir_11b_22M;                        ///< 11bź˲ 1ʹ˲
    WIFI_PSDU psdu;                         ///< PSDU
    int Reserved[128];                      ///< λ
} Set11B;

typedef struct
{
    int MCS;                                ///< 0~31
    int HtFrmType;                          ///< 11n  GF/MF. HT_FRAME_TYPE_ENUM
    int NSS;                                ///< ռ
    int NotSounding;                        ///< 0 = OFF, 1 = ON. ʹ
    int SmoothingEnable;                    ///< 0 = disable, 1 = enable
    int isAggregation;                      ///< Ƿϣpsduǰ4ֽڵϢ
    int isShortGI;                          ///< 0 = long GI, 1 = short GI. ǷGI
    int CodingType;                         ///< 0 = BCC, 1 = LDPC
    int STBC;                               ///< 0 = disable, 1 = enable
    WIFI_PSDU psdu;                         ///< PSDU
    int Reserved[128];                      ///< λ
} Set11N;

typedef struct
{
    int MCS;                                ///< 0~11
    int NSS;                                ///< ȡֵΧ[1~8], ռ
    int isShortGI;                          ///< 0 = long GI, 1 = short GI. ǷGI
    int CodingType;                         ///< 0 = BCC, 1 = LDPC
    int STBC;                               ///< PSDU
    WIFI_PSDU psdu;                         ///< PSDU
    int Reserved[128];                      ///< λ
} Set11AC;

typedef struct
{
    int STBC;                                   ///< STBC
    int UL_DL;                                  ///<  ĬΪ0
    int MCS;                                    ///< Χֵ0~11
    int NSS;                                    ///< 1~8DopplerЧʱNSSΪ4
    int CodingType;                             ///< BCC/LDPC,0=BCC,1=LDPC 
    int PE;                                     ///< (0/1), 0=disable, 1=enable; ĬֵΪ0
    int GILTFSize;                              ///< 11ax0~3 .ĬֵΪ3
    int Spatial_Reuse[4];                       ///< ĬȥһֵȡֵΧ[0~15]
    int BeamChange;                             ///< (0/1),ĬΪ1
    int BSScolor;                               ///< BSS color,0 - 63 (initial 63)
    int TXOP;                                   ///< TXOP Duration,0 - 127 (initial 127)
    int Doppler;                                ///< Doppler,0 :Disable(initial), 1 : Enable
    int DCM;                                    ///< ָʾǷҪ˫ز 0/10=disable, 1=enable
    int PE_Type;                                ///< 0=0us, 1=8us, 2=16us; PE=1ʱЧ
    int Midamble_Periodicity;                   ///< (1/2)1=10symbol, 2=20symbolDoppler=1ʱЧ
    WIFI_PSDU psdu;                             ///< PSDU
    int Reserved[128];                          ///< λ
}Set11AX_SU;

typedef struct
{
    int AID;                        ///< UserAID.1 - 2007(initial 1)
    double PowerFact;               ///< RUӡȡֵ[0.5, 0.707, 1, 1.414, 2]Ĭֵ 1
    int CodingType;                 ///< BCC/LDPC0=BCC, 1=LDPC 
    int DCM;                        ///< ָʾǷҪ˫زơ0=disable, 1=enable
    int MCS;                        ///< ȡֵΧ[0~11]Ĭֵ7
    int NSS;                        ///< ȡֵΧ[1~8]DopplerЧʱNSSΪ4
    WIFI_PSDU psdu;                 ///< PSDU
    int Reserved[128];              ///< λ
}MUMIMO_User;

typedef struct
{
    int Q_Flag;                 ///< QǷЧ0=disable, 1=enable
    int Q_NTX;                  ///< QTxȡֵΧ[1~8]Ĭֵ1
    int Q_Type;                 ///< Q
    int QDelay[8];              ///< QУÿTx֮ʱ
    Complex MatrValue[8][8];    ///< Qĸ
    int Reserved[128];          ///< λ
}MUMIMO_QMat;

typedef struct
{
    int UserNum;                        ///< RUUserȡֵ[0~8]
    MUMIMO_QMat Qmat;                   ///< RUQ
    MUMIMO_User User[MUMIMO_8_USER];    ///< RUUser
    int Reserved[128];                  ///< λ
}MUMIMO_RU;

typedef struct
{
    int FullBand;                               ///<[0~1],1==full band
    int STBC;                                   ///< STBC.0=disable, 1=enable; ĬֵΪ0
    int UL_DL;                                  ///<  ĬΪ0
    int PE;                                     ///< (0/1), 0=disable, 1=enable; ĬֵΪ0
    int GILTFSize;                              ///< 11ax0~3 .ĬֵΪ3
    int BSScolor;                               ///< BSS color,0 - 63 (initial 63)
    int TXOP;                                   ///< TXOP Duration,0 - 127 (initial 127)
    int Doppler;                                ///< Doppler,0 :Disable(initial), 1 : Enable
    int Spatial_Reuse[4];                       ///< 
    int PE_Type;                                ///<  0=0us, 1=8us, 2=16us; PE=1ʱЧ
    int Midamble_Periodicity;                   ///< (1/2)1=10symbol, 2=20symbolDoppler=1ʱЧ

    MUMIMO_RU RU[AX_RU_COUNT];

    int SIGBMCS;                                ///< (0~5)%ָʾmcs ֵΧ0~5
    int SIGBDCM;                                ///< (0/1) %ָʾǷ˫ز
    int SIGB_Compression;                       ///< (0/1) %ָʾsigBǷڣĬΪ1

    int RuAllocMap[8];                          ///< 11axcommon8bit ʮʽ
    int RuAllocExtra[2];                        ///< center 26-tone RUӦ80M160Mе,1=enable,0=disable
    int Reserved[128];                          ////< λ
} Set11AX_MU;


typedef struct
{
    int AID;                        ///< UserAID.1 - 2007(initial 1)
    double PowerFact;               ///< RUӡȡֵ[0.5, 0.707, 1, 1.414, 2]Ĭֵ 1
    int CodingType;                 ///< BCC 
    int DCM;                        ///< ָʾǷҪ˫ز 0/10=disable, 1=enable
    int MCS;                        ///< Χֵ0~11
    int NSS;                        ///< 1~8DopplerЧʱNSSΪ4MU-MIMOΪ4
    int NSSStart;	                ///< TB MUMIMOʼҪãͬRU²ͬUserռݵͬNSSstartNSSһڵľ
    int SegmentIndex;               ///< RURUINXд뵽ÿUserͬRUUserֵһ
    int RUIndex;		            ///< RURUINXд뵽ÿUserͬRUUserֵһ
    WIFI_PSDU psdu;                 ///< RUUserPSDU
    int Reserved[128];              ///< λ
}TB_MUMIMO_User;

typedef struct
{
    int UserNum;			            ///< RUUserȡֵ[1~8]	
    MUMIMO_QMat Qmat;		            ///< ͬMUMIMOµQ趨ÿRUһ
    TB_MUMIMO_User User[MUMIMO_8_USER]; ///< RUUserãÿRU8
    int Reserved[128]; 	                ///< λ
}TB_MUMIMO_RU;

typedef struct
{
    int STBC;
    int NumLTFSymbols;		                    ///< TBеģTB MUMIMOΪ2xHELTFĬ2
    int MULTFMode;	                            ///< TB MUMIMOУȡֵΪ01Ĭ0
    int GILTFSize;                              ///< 11ax0~2 . Ĭֵ2
    int Spatial_Reuse[4];                       ///< οTBΪ416볣MU-MIMOһ
    int TXOP;                                   ///< TXOP Duration,0 - 127 (initial 127)
    int BSScolor;                               ///< BSS color,0 - 63 (initial 63)
    int Doppler;                                ///< Doppler,0 :Disable(initial), 1 : Enable
    int Midamble_Periodicity;                   ///< (1/2)1=10symbol, 2=20symbolDoppler=1ʱЧ
    int PE;                                     ///< (0/1), 0=disable, 1=enable; ĬֵΪ0
    int PE_Type;                                ///<  0=0us, 1=8us, 2=16us; PE=1ʱЧ
    int TBMUMIMOFlag; 	                        ///< ̶ֵ1TBMUMIMO
    int RUNum[MAX_SEGMENT];                     ///< ÿsegment RU
    TB_MUMIMO_RU RU[MAX_SEGMENT][AX_RU_COUNT];  ///< MAX_SEGMENTΪSegmentţAX_RU_COUNTӦǽRU IDţ0
    int LDPC_Extra;                             ///< TBLDPCExtra
    int Pre_FECfactor;                          ///< TBAfactor
    int PE_Disambiguity;                        ///< PE_Disambiguity
    int Reserved[125];                          ///< λ
} Set11AX_TB;

typedef struct
{
    int CodingType;                     ///<ȡֵΧ[0~1],0=BCC1=LDPC
    int MCS;                            ///<ȡֵΧ[0~11]
    int NSS;                            ///<, ȡֵΧ[1~8]
    WIFI_PSDU psdu;                     ///< PSUD        
    int Reserved[128];
}AC_MUMIMO_User;

typedef struct
{
    int UserNum;                            ///< ûȡֵΧ[1~4]
    int GI;                                 ///< GIͣ0=short GI, 1=long GI
    int GroupID;                            ///< ȡֵΧ[1~62] 
    int TXOP_PS_NOT_ALLOWED;                ///<
    MUMIMO_QMat Qmat;                       ///< Q
    AC_MUMIMO_User User[AC_MUMIMO_4_USER];
    int Reserved[128];
}Set11AC_MUMIMO;

typedef struct
{
    //standardsubTypeȷҪź
    int standard;                               ///< źű׼. οVsaParameter.Demode
    int subType;                                ///< PPDU
    int bandwidth;                              ///< , λMHz (20:20M; 40:40M; 80:80M; 160:160M; 160:8080M)
    int samplingRate;                           ///< , λHz
    int NSS;                                    ///< stream
    int segment;                                ///< segmentĬֵ180+80Mźʱֵ2
    double FreqErr;                             ///< Ƶƫ
    double IQImbalanceAmp;                      ///< IQƽȵ
    double IQImbalancePhase;                    ///< IQƽλ
    double DCOffset_I;                          ///< DC offset I
    double DCOffset_Q;                          ///< DC offset Q
    double ClockRate;                           ///< Clock rate
    double Snr;                                 ///< SNR
    double Gap;                                 ///< λ: Sec,default 10us, 0.00001s
    int Reserved[252];                          ///< 
} PNSettingBase;


typedef struct
{
    PNSettingBase commonParam;
    union
    {
        Set11A PN11a;
        Set11B PN11b;
        Set11N PN11n;
        Set11AC PN11ac;
        Set11AC_MUMIMO PN11ac_MUMIMO;
        Set11AX_SU PN11ax_SU;
        Set11AX_MU PN11ax_MU;
        Set11AX_TB PN11ax_TB;
    };
    TriggerFrameSetting TrigFrame;
    void *ExtendParam;

}GenWaveWifiStruct;


typedef struct
{
    //Header format
    int LT_ADDR;                    //  3bit  LT_ADDR3bitȡֵ0~7
    int PackType;                   //  4bit  TYPE: ͣĿǰҪ֧DH1DH3DH5,2DH1,2DH3,2DH5,3DH1,3DH3,3DH5
    int Flow;                       //  1bit  FLOW: FLOW_Control1bitȡֵ0~1
    int ARQN;                       //  1bit  ARQN: ACK Indication1bitȡֵ0~1
    int SEQN;                       //  1bit  SEQN: Seq Number Inder1bitȡֵ0~1

                                    //Payload
    int LLID;                       // Logical Link Identifier(LLID):ȡֵ0~3 :Ĭϣ1
    int DataWhitening;              // ǷҪ루ֵΪ1ֵΪ0Ĭϲ룺0
    int payLoadType;                //BLEԵʱָصͣPackTypeѡLE_TESTʱЧ
    int mFlow;                      //Flowȡֵ0,1

                                    //PHY Parameters
    double FreqDeviation;           // Freq Deviation115kHz-300kHzĬ160kHz
    double ModuIdex;                //Modulation Indexȡֵ0.01~0.99(ֻ֧λС)   ԭFreqDeviationֶ޸
    int BTProductIdex;              //Filter BT Product ȡֵ0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9
    int RolloffIdex;                //EDR Filter Rolloff  ȡֵ0.30.35,0.40,0.45,0.50
    int GuardTime;                  //EDR Guard Time us;IQXEL0~10000usֻȡ

                                    //Device Address Part
    unsigned int LAP;               // LAP(Lower Address Part)24bit Ĭϣ0x000000
    unsigned char  UAP;             // UAP(Upper Address Part)8bit Ĭϣ0x47
    unsigned int NAP;               // NAP(Non-significant Address Part)16bit Ĭϣ0x0000

                                    //Packet Ramp Time
    double PowerRampTime;           //us Ĭϣ2us
    double PowerSettlingTime;       //us Ĭϣ4us

                                    //LE packetType
    int LE_PayloadType;				//Payload type 0~7
    unsigned int LE_SyncWord;	    //32bit Ĭȡֵ94826e8e(Ϊλ A=1010)

    int BTHeadZeroCount;            //BTźͷ
    int BTAddZeroCount;             //BTźβ

    int BLEMapperS;                 //ֻenPacketType_LE_Coded_TestЧȡֵ28

    int PayLoadSize;				// payload(PSDU)
    int Reserved[64];				//
} BlueToothPacketSet;


typedef struct
{
    PNSettingBase commonParam;
    int psduLen;
    int Reserved[128];    //
}GenWaveCwStruct;

typedef struct
{
    PNSettingBase commonParam;
    BlueToothPacketSet BtPacketSet;
    int Reserved[128];    //
}GenWaveBtStruct;

#endif